ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.8 by root, Tue Dec 7 19:55:56 2010 UTC vs.
Revision 1.23 by root, Sat Dec 18 13:58:12 2010 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38export PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
52postconfigure() { : ; } 51postconfigure() { : ; }
53postbuild() { : ; } 52postbuild() { : ; }
54postinstall() { : ; } 53postinstall() { : ; }
55 54
56# now source user config, if any 55# now source user config, if any
56if [ "$STATICPERLRC" ]; then
57 . "$STATICPERLRC"
58else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 59 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 60 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 61 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
62fi
60 63
61############################################################################# 64#############################################################################
62# support 65# support
66
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
71export LC_ALL=C # just to be on the safe side
63 72
64# set version in a way that Makefile.PL can extract 73# set version in a way that Makefile.PL can extract
65VERSION=VERSION; eval \ 74VERSION=VERSION; eval \
66$VERSION=0.1 75$VERSION=0.912
67 76
68BZ2=bz2 77BZ2=bz2
69BZIP2=bzip2 78BZIP2=bzip2
70 79
71fatal() { 80fatal() {
104############################################################################# 113#############################################################################
105# clean 114# clean
106 115
107distclean() { 116distclean() {
108 verblock <<EOF 117 verblock <<EOF
109deleting everything installed by this script 118 deleting everything installed by this script (rm -rf $STATICPERL)
110EOF 119EOF
111 120
112 rm -rf "$STATICPERL" 121 rm -rf "$STATICPERL"
113} 122}
114 123
115############################################################################# 124#############################################################################
116# download/configure/compile/install perl 125# download/configure/compile/install perl
117 126
118clean() { 127clean() {
119 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
129}
130
131realclean() {
132 rm -f "$PERL_PREFIX/staticstamp.postinstall"
133 rm -f "$PERL_PREFIX/staticstamp.install"
134 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
120} 135}
121 136
122fetch() { 137fetch() {
123 rcd "$STATICPERL" 138 rcd "$STATICPERL"
124 139
139 154
140 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 155 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
141 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 156 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
142 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 157 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 || fatal "$URL: unable to download" 158 || fatal "$URL: unable to download"
159 rm -f perl-$PERL_VERSION.tar.$BZ2
144 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 160 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
145 fi 161 fi
146 162
147 verblock <<EOF 163 verblock <<EOF
148unpacking perl 164unpacking perl
149EOF 165EOF
150 166
151 mkdir -p unpack 167 mkdir -p unpack
168 rm -rf unpack/perl-$PERL_VERSION
152 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xC unpack \ 169 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
153 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 170 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
154 chmod -R u+w unpack/perl-$PERL_VERSION 171 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 172 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 173 rmdir -p unpack
157 fi 174 fi
158} 175}
159 176
160# similar to GNU-sed -i or perl -pi 177# similar to GNU-sed -i or perl -pi
161sedreplace() { 178sedreplace() {
162 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 179 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
180 rm -f "$2"
163 mv "$2~" "$2" 181 mv "$2~" "$2"
182}
183
184configure_failure() {
185 cat <<EOF
186
187
188***
189*** Configure failed - see above for the exact error message(s).
190***
191*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
192*** flags are not supported by your compiler. Less often, this is because
193*** PERL_LIBS either contains a library not available on your system (such as
194*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
195***
196*** You can provide your own flags by creating a ~/.staticperlrc file with
197*** variable assignments. For example (these are the actual values used):
198***
199
200PERL_CC="$PERL_CC"
201PERL_CCFLAGS="$PERL_CCFLAGS"
202PERL_OPTIMIZE="$PERL_OPTIMIZE"
203PERL_LDFLAGS="$PERL_LDFLAGS"
204PERL_LIBS="$PERL_LIBS"
205
206EOF
207 exit 1
164} 208}
165 209
166configure() { 210configure() {
167 fetch 211 fetch
168 212
174configuring $STATICPERL/src/perl-$PERL_VERSION 218configuring $STATICPERL/src/perl-$PERL_VERSION
175EOF 219EOF
176 220
177 rm -f "$PERL_PREFIX/staticstamp.install" 221 rm -f "$PERL_PREFIX/staticstamp.install"
178 222
179 make distclean >/dev/null 2>&1 223 "$MAKE" distclean >/dev/null 2>&1
180 224
225 sedreplace '/^#define SITELIB/d' config_h.SH
226
181 # I hate them 227 # I hate them for this
182 grep -q -- -fstack-protector Configure && \ 228 grep -q -- -fstack-protector Configure && \
183 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 229 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
184 230
185 preconfigure 231 preconfigure
186 232
190 -Dusemymalloc=n \ 236 -Dusemymalloc=n \
191 -Uusedl \ 237 -Uusedl \
192 -Uusethreads \ 238 -Uusethreads \
193 -Uuseithreads \ 239 -Uuseithreads \
194 -Uusemultiplicity \ 240 -Uusemultiplicity \
195 -Duseperlio \
196 -Uusesfio \ 241 -Uusesfio \
197 -Uuseshrplib \ 242 -Uuseshrplib \
198 -Dcppflags="$PERL_CPPFLAGS" \ 243 -A ccflags=" $PERL_CCFLAGS" \
199 -Dccflags="-g2 -fno-strict-aliasing" \ 244 -Dcc="$PERL_CC" \
200 -Doptimize="$PERL_OPTIMIZE" \ 245 -Doptimize="$PERL_OPTIMIZE" \
201 -Dldflags="$PERL_LDFLAGS" \ 246 -Dldflags="$PERL_LDFLAGS" \
202 -Dlibs="$PERL_LIBS" \ 247 -Dlibs="$PERL_LIBS" \
203 -Dprefix="$PERL_PREFIX" \ 248 -Dprefix="$PERL_PREFIX" \
204 -Dbin="$PERL_PREFIX/bin" \ 249 -Dbin="$PERL_PREFIX/bin" \
205 -Dprivlib="$PERL_PREFIX/lib" \ 250 -Dprivlib="$PERL_PREFIX/lib" \
206 -Darchlib="$PERL_PREFIX/lib" \ 251 -Darchlib="$PERL_PREFIX/lib" \
207 -Uusevendorprefix \ 252 -Uusevendorprefix \
208 -Dsitelib="$PERL_PREFIX/lib" \ 253 -Dsitelib="$PERL_PREFIX/lib" \
209 -Dsitearch="$PERL_PREFIX/lib" \ 254 -Dsitearch="$PERL_PREFIX/lib" \
210 -Usitelibexp \
211 -Uman1dir \ 255 -Uman1dir \
212 -Uman3dir \ 256 -Uman3dir \
213 -Usiteman1dir \ 257 -Usiteman1dir \
214 -Usiteman3dir \ 258 -Usiteman3dir \
215 -Dpager=/usr/bin/less \ 259 -Dpager=/usr/bin/less \
216 -Demail="$EMAIL" \ 260 -Demail="$EMAIL" \
217 -Dcf_email="$EMAIL" \ 261 -Dcf_email="$EMAIL" \
218 -Dcf_by="$EMAIL" \ 262 -Dcf_by="$EMAIL" \
219 $PERL_CONFIGURE \ 263 $PERL_CONFIGURE \
264 -Duseperlio \
220 -dE || fatal "Configure failed" 265 -dE || configure_failure
221 266
222 sedreplace ' 267 sedreplace '
223 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 268 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
224 s/ *-fno-stack-protector */ /g 269 s/ *-fno-stack-protector */ /g
225 ' config.sh 270 ' config.sh
240building $STATICPERL/src/perl-$PERL_VERSION 285building $STATICPERL/src/perl-$PERL_VERSION
241EOF 286EOF
242 287
243 rm -f "$PERL_PREFIX/staticstamp.install" 288 rm -f "$PERL_PREFIX/staticstamp.install"
244 289
245 make || fatal "make: error while building perl" 290 "$MAKE" || fatal "make: error while building perl"
246 291
247 postbuild || fatal "postbuild hook failed" 292 postbuild || fatal "postbuild hook failed"
248} 293}
249 294
250install() { 295install() {
251 [ -e "$PERL_PREFIX/staticstamp.install" ] && return 296 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
252
253 build 297 build
254 298
255 verblock <<EOF 299 verblock <<EOF
256installing $STATICPERL/src/perl-$PERL_VERSION 300installing $STATICPERL/src/perl-$PERL_VERSION
257to $PERL_PREFIX 301to $PERL_PREFIX
258EOF 302EOF
259 303
260 rm -rf "$PERL_PREFIX" 304 ln -sf "perl/bin/" "$STATICPERL/bin"
261 305 ln -sf "perl/lib/" "$STATICPERL/lib"
306
307 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
308 rm -rf "$PERL_PREFIX" # by this rm -rf
309
262 make install || fatal "make install: error while installing" 310 "$MAKE" install || fatal "make install: error while installing"
263 311
264 rcd "$PERL_PREFIX" 312 rcd "$PERL_PREFIX"
265 313
266 # create a "make install" replacement for CPAN 314 # create a "make install" replacement for CPAN
267 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 315 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
268make install UNINST=1 316"$MAKE" || exit
317
269if find blib/arch/auto -type f | grep -q -v .exists; then 318if find blib/arch/auto -type f | grep -q -v .exists; then
270 echo Probably an XS module, rebuilding perl 319 echo Probably an XS module, rebuilding perl
271 make perl 320 if "$MAKE" perl; then
321 mv perl "$PERL_PREFIX"/bin/perl~ \
272 rm -f "$PERL_PREFIX"/bin/perl 322 && rm -f "$PERL_PREFIX"/bin/perl \
273 make -f Makefile.aperl inst_perl 323 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
274 make -f Makefile.aperl map_clean 324 "$MAKE" -f Makefile.aperl map_clean
325 else
326 "$MAKE" -f Makefile.aperl map_clean
327 exit 1
328 fi
275fi 329fi
330
331"$MAKE" install UNINST=1
276EOF 332EOF
277 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 333 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
278 334
279 # trick CPAN into avoiding ~/.cpan completely 335 # trick CPAN into avoiding ~/.cpan completely
280 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 336 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
281 337
282 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 338 "$PERL_PREFIX"/bin/perl -MCPAN -e '
283 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 339 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
284 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 340 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
285 CPAN::Shell->o (conf => q<init>); 341 CPAN::Shell->o (conf => q<init>);
286 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
287 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 343 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
288 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 344 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
289 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 345 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
290 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 346 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
291 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 347 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
292 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 348 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
293 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 349 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
294 CPAN::Shell->o (conf => q<commit>); 350 CPAN::Shell->o (conf => q<commit>);
295 ' || fatal "error while initialising CPAN" 351 ' || fatal "error while initialising CPAN"
296 352
353 touch "$PERL_PREFIX/staticstamp.install"
354 fi
355
356 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
297 NOCHECK_INSTALL=+ 357 NOCHECK_INSTALL=+
298 instcpan $STATICPERL_MODULES 358 instcpan $STATICPERL_MODULES
299 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 359 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
300 360
301 postinstall || fatal "postinstall hook failed" 361 postinstall || fatal "postinstall hook failed"
302 362
303 touch "$PERL_PREFIX/staticstamp.install" 363 touch "$PERL_PREFIX/staticstamp.postinstall"
364 fi
304} 365}
305 366
306############################################################################# 367#############################################################################
307# install a module from CPAN 368# install a module from CPAN
308 369
335 for mod in "$@"; do 396 for mod in "$@"; do
336 echo 397 echo
337 echo $mod 398 echo $mod
338 ( 399 (
339 rcd $mod 400 rcd $mod
340 make -f Makefile.aperl map_clean >/dev/null 2>&1 401 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
341 make distclean >/dev/null 2>&1 402 "$MAKE" distclean >/dev/null 2>&1
342 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 403 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
343 make || fatal "$mod: error building module" 404 "$MAKE" || fatal "$mod: error building module"
344 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 405 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
345 make distclean >/dev/null 2>&1 406 "$MAKE" distclean >/dev/null 2>&1
346 exit 0 407 exit 0
347 ) || exit $? 408 ) || exit $?
348 done 409 done
349} 410}
350 411
351############################################################################# 412#############################################################################
352# main 413# main
353 414
354podusage() { 415podusage() {
355 echo 416 echo
417
356 if [ -e "$PERL_PREFIX/bin/perl" ]; then 418 if [ -e "$PERL_PREFIX/bin/perl" ]; then
357 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 419 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
358 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 420 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
359 2>/dev/null && exit 421 2>/dev/null && exit
360 fi 422 fi
423
361 # try whatever perl we can find 424 # try whatever perl we can find
362 perl -MPod::Usage -e \ 425 perl -MPod::Usage -e \
363 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 426 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
364 2>/dev/null && exit 427 2>/dev/null && exit
365 428
366 fatal "displaying documentation requires a working perl - try '$0 install' first" 429 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
367} 430}
368 431
369usage() { 432usage() {
370 podusage 0 433 podusage 0
371} 434}
381} 444}
382 445
383bundle() { 446bundle() {
384 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 447 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
385 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 448 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
449 CACHE="$STATICPERL/cache"
450 mkdir -p "$CACHE"
386 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 451 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
387} 452}
388 453
389if [ $# -gt 0 ]; then 454if [ $# -gt 0 ]; then
390 while [ $# -gt 0 ]; do 455 while [ $# -gt 0 ]; do
391 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 456 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
392 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 457 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
393 458
394 command="${1#--}"; shift 459 command="${1#--}"; shift
395 case "$command" in 460 case "$command" in
461 version )
462 echo "staticperl version $VERSION"
463 ;;
396 fetch | configure | build | install | clean | distclean) 464 fetch | configure | build | install | clean | realclean | distclean)
397 verblock <<EOF
398$command
399EOF
400 ( "$command" ) 465 ( "$command" ) || exit
401 ;; 466 ;;
402 instsrc ) 467 instsrc )
403 ( instsrc "$@" ) 468 ( instsrc "$@" ) || exit
404 exit 469 exit
405 ;; 470 ;;
406 instcpan ) 471 instcpan )
407 ( instcpan "$@" ) 472 ( instcpan "$@" ) || exit
408 exit 473 exit
409 ;; 474 ;;
410 cpan ) 475 cpan )
411 ( install ) 476 ( install ) || exit
412 "$PERL_PREFIX/bin/cpan" "$@" 477 "$PERL_PREFIX/bin/cpan" "$@"
413 exit 478 exit
414 ;; 479 ;;
415 mkbundle ) 480 mkbundle )
416 ( install ) 481 ( install ) || exit
417 bundle "$@" 482 bundle "$@"
418 exit 483 exit
419 ;; 484 ;;
420 mkperl ) 485 mkperl )
421 ( install ) 486 ( install ) || exit
422 bundle --perl "$@" 487 bundle --perl "$@"
488 exit
489 ;;
490 mkapp )
491 ( install ) || exit
492 bundle --app "$@"
423 exit 493 exit
424 ;; 494 ;;
425 help ) 495 help )
426 podusage 2 496 podusage 2
427 ;; 497 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines